// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'icmp.pas' rev: 3.00

#ifndef icmpHPP
#define icmpHPP
#include <WinSock.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Icmp
{
//-- type declarations -------------------------------------------------------
typedef int TIPAddr;

typedef int TIPMask;

typedef int TIPStatus;

struct TIPOptionInformation;
typedef TIPOptionInformation *PIPOptionInformation;

#pragma pack(push, 1)
struct TIPOptionInformation
{
	Byte TTL;
	Byte TOS;
	Byte Flags;
	Byte OptionsSize;
	char *OptionsData;
} ;
#pragma pack(pop)

struct TIcmpEchoReply;
typedef TIcmpEchoReply *PIcmpEchoReply;

#pragma pack(push, 1)
struct TIcmpEchoReply
{
	int Address;
	int Status;
	int RTT;
	Word DataSize;
	Word Reserved;
	void *Data;
	TIPOptionInformation Options;
} ;
#pragma pack(pop)

typedef int __stdcall (*TIcmpCreateFile)(void);

typedef bool __stdcall (*TIcmpCloseHandle)(int IcmpHandle);

typedef int __stdcall (*TIcmpSendEcho)(int IcmpHandle, int DestinationAddress, void * RequestData, Word 
	RequestSize, PIPOptionInformation RequestOptions, void * ReplyBuffer, int ReplySize, int Timeout);

typedef void __fastcall (__closure *TICMPDisplay)(System::TObject* Sender, System::AnsiString Msg);

typedef void __fastcall (__closure *TICMPReply)(System::TObject* Sender, int Error);

class DELPHICLASS TICMP;
class PASCALIMPLEMENTATION TICMP : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Windows::HINST hICMPdll;
	TIcmpCreateFile IcmpCreateFile;
	TIcmpCloseHandle IcmpCloseHandle;
	TIcmpSendEcho IcmpSendEcho;
	int hICMP;
	TIcmpEchoReply FReply;
	System::AnsiString FAddress;
	System::AnsiString FHostName;
	System::AnsiString FHostIP;
	int FIPAddress;
	int FSize;
	int FTimeOut;
	int FTTL;
	TICMPDisplay FOnDisplay;
	Classes::TNotifyEvent FOnEchoRequest;
	TICMPReply FOnEchoReply;
	int FLastError;
	bool FAddrResolved;
	void __fastcall ResolveAddr(void);
	
public:
	__fastcall virtual TICMP(void);
	__fastcall virtual ~TICMP(void);
	int __fastcall Ping(void);
	void __fastcall SetAddress(System::AnsiString Value);
	System::AnsiString __fastcall GetErrorString();
	__property System::AnsiString Address = {read=FAddress, write=SetAddress};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property int Timeout = {read=FTimeOut, write=FTimeOut, nodefault};
	__property TIcmpEchoReply Reply = {read=FReply};
	__property int TTL = {read=FTTL, write=FTTL, nodefault};
	__property int ErrorCode = {read=FLastError, nodefault};
	__property System::AnsiString ErrorString = {read=GetErrorString};
	__property System::AnsiString HostName = {read=FHostName};
	__property System::AnsiString HostIP = {read=FHostIP};
	__property TICMPDisplay OnDisplay = {read=FOnDisplay, write=FOnDisplay};
	__property Classes::TNotifyEvent OnEchoRequest = {read=FOnEchoRequest, write=FOnEchoRequest};
	__property TICMPReply OnEchoReply = {read=FOnEchoReply, write=FOnEchoReply};
};

class DELPHICLASS TICMPException;
class PASCALIMPLEMENTATION TICMPException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall TICMPException(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall TICMPException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall TICMPException(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall TICMPException(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall TICMPException(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall TICMPException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall TICMPException(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall TICMPException(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~TICMPException(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define IcmpVersion (Byte)(102)
#define IcmpDLL "icmp.dll"
#define IP_SUCCESS (Byte)(0)
#define IP_STATUS_BASE (Word)(11000)
#define IP_BUF_TOO_SMALL (Word)(11001)
#define IP_DEST_NET_UNREACHABLE (Word)(11002)
#define IP_DEST_HOST_UNREACHABLE (Word)(11003)
#define IP_DEST_PROT_UNREACHABLE (Word)(11004)
#define IP_DEST_PORT_UNREACHABLE (Word)(11005)
#define IP_NO_RESOURCES (Word)(11006)
#define IP_BAD_OPTION (Word)(11007)
#define IP_HW_ERROR (Word)(11008)
#define IP_PACKET_TOO_BIG (Word)(11009)
#define IP_REQ_TIMED_OUT (Word)(11010)
#define IP_BAD_REQ (Word)(11011)
#define IP_BAD_ROUTE (Word)(11012)
#define IP_TTL_EXPIRED_TRANSIT (Word)(11013)
#define IP_TTL_EXPIRED_REASSEM (Word)(11014)
#define IP_PARAM_PROBLEM (Word)(11015)
#define IP_SOURCE_QUENCH (Word)(11016)
#define IP_OPTION_TOO_BIG (Word)(11017)
#define IP_BAD_DESTINATION (Word)(11018)
#define IP_ADDR_DELETED (Word)(11019)
#define IP_SPEC_MTU_CHANGE (Word)(11020)
#define IP_MTU_CHANGE (Word)(11021)
#define IP_GENERAL_FAILURE (Word)(11050)
#define MAX_IP_STATUS (Word)(11050)
#define IP_PENDING (Word)(11255)
#define IP_FLAG_DF (Byte)(2)
#define IP_OPT_EOL (Byte)(0)
#define IP_OPT_NOP (Byte)(1)
#define IP_OPT_SECURITY (Byte)(130)
#define IP_OPT_LSRR (Byte)(131)
#define IP_OPT_SSRR (Byte)(137)
#define IP_OPT_RR (Byte)(7)
#define IP_OPT_TS (Byte)(68)
#define IP_OPT_SID (Byte)(136)
#define MAX_OPT_SIZE (Byte)(64)

}	/* namespace Icmp */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Icmp;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// icmp
